// SPDX-License-Identifier: Apache-2.0
import ValidatedRequest from "../../../../core/validation/ValidatedArgs";
import FormatValidation from "../FormatValidation";
import { SecurityDate } from "../../../../domain/context/shared/SecurityDate";
export default class SetScheduledBalanceAdjustmentRequest extends ValidatedRequest {
    securityId;
    executionDate;
    factor;
    decimals;
    constructor({ securityId, executionDate, factor, decimals, }) {
        super({
            securityId: FormatValidation.checkHederaIdFormatOrEvmAddress(),
            executionDate: (val) => {
                return SecurityDate.checkDateTimestamp(parseInt(val), Math.ceil(new Date().getTime() / 1000));
            },
            factor: FormatValidation.checkAmount(),
            decimals: FormatValidation.checkAmount(true),
        });
        this.securityId = securityId;
        this.executionDate = executionDate;
        this.factor = factor;
        this.decimals = decimals;
    }
}
